#include <EasyUltrasonic.h>
#define MYTRIGPIN 7 // Digital pin connected to the trig pin of the ultrasonic sensor
#define MYECHOPIN 8 // Digital pin connected to the echo pin of the ultrasonic sensor
#define OUTSIDELEDPIN 11
#define INSIDELEDPIN 10
#define BuzzerPin 9

int pitch_modifier;
int lightMode = 0;
static int outsideLEDIntensity = 0;
int outsideLEDFullLitDuration;
int outsideLEDOffDuration;
static int previousOutsideLEDIntensity;
int previousWhiteLEDIntensity;
int outsideLEDFlashingIterations;
int i;
int intensityDifference = 0;

EasyUltrasonic ultrasonic;

void scaryNoise(int duration) {  
  int time = 0;
  int frequency = 0;
  int waitTime = 0;
  int whiteNoiseDuration = random(0,100);
  pitch_modifier = random(0,100);
  
  whiteNoise(whiteNoiseDuration);
  while (time <= duration) {
    time++;
    frequency = random(400, 2000);
    frequency += pitch_modifier;
    tone(BuzzerPin, frequency);
    waitTime = random(0, 15);
    
    delay(waitTime);
  }
  noTone(BuzzerPin);
}

void whiteNoise(int duration) {  
  int time = 0;
  int frequency = 0;
  pitch_modifier = random(0,50);
  
  while (time <= duration) {
    time++;
    frequency = random(500, 1000);
    frequency += pitch_modifier;
    tone(BuzzerPin, frequency);
    delay(1);
  }
  noTone(BuzzerPin);
}

void staticNoise(int duration) {
  int time = 0;
  int frequency = 0;
  while (time <= duration) {
    time++;
    frequency = 50; // European AC frequency
    
    tone(BuzzerPin, frequency);
    delay(1);
  }
  noTone(BuzzerPin);
}

void setup() {  
  // put your setup code here, to run once:
  Serial.begin(9600); // Open the serial port
  
  ultrasonic.attach(MYTRIGPIN, MYECHOPIN); // Attaches the ultrasonic sensor on the specified pins on the ultrasonic object
  
  pinMode(INSIDELEDPIN, OUTPUT);
  pinMode(OUTSIDELEDPIN, OUTPUT);
  pinMode(BuzzerPin, OUTPUT);
  outsideLEDIntensity = 0;
  lightMode = 0;

}

void loop() {
  // put your main code here, to run repeatedly:
  float distanceCM = ultrasonic.getDistanceCM(); // Read the distance in centimeters
  // float distanceCM = 0;
  long intensiteAllumage = random(0,255);
  //int frequenceBuzzer = random(50,400);
  // Print the distance value in Serial Monitor
  // Serial.print(distanceCM);
  // Serial.println(" cm");

  if (distanceCM <= 100) {
    // pres: on declenche le son qui fait peur
    // scaryNoise(20);
    scaryNoise(2);
    
    // et on fait clignotter la LED rouge
    analogWrite(INSIDELEDPIN, intensiteAllumage);
    digitalWrite(OUTSIDELEDPIN, LOW);
    delay(random(5,100));
    digitalWrite(INSIDELEDPIN, LOW);
  }
  else {
    // Loin: on allume la blanche on éteint la rouge
	  previousOutsideLEDIntensity = outsideLEDIntensity;
  	lightMode = random(0, 11);
    // lightMode = 5;
  	//Serial.println(lightMode);
      
      if (lightMode == 10) {  // Full lit for longer
        //Serial.println("--- Red Full ---");
      
        outsideLEDIntensity = 255;
        
        outsideLEDFullLitDuration = random(500, 4000);
        analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);

        if (previousOutsideLEDIntensity != outsideLEDIntensity) { whiteNoise(10); }
        staticNoise(outsideLEDFullLitDuration);

      } else {
        if (lightMode == 0) {  // completely off for longer
          // Serial.println("--- Red OFF ---");
          outsideLEDOffDuration = random(500, 1000);
          outsideLEDIntensity = 0;
          analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);
          if (previousOutsideLEDIntensity != outsideLEDIntensity) { whiteNoise(10); }
          delay(outsideLEDOffDuration);
        }
        else if (lightMode == 9) {  // flashing
          // Serial.println("--- Red Flashing ---");
          outsideLEDFlashingIterations = random (1,10);
          i=0;
          while(i < outsideLEDFlashingIterations)
          {
            i++;
            outsideLEDIntensity = 255;
            // outsideLEDIntensity = random(150,255);
            analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);
            whiteNoise(2);
            staticNoise(2);
            delay(random(5,200));
            outsideLEDIntensity = 0;
            analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);
            whiteNoise(2);
            delay(random(5,200));
          }
        }
        else if(lightMode < 5) {   // various DIM
          Serial.println("--- Red Intermediate ---");
          // outsideLEDIntensity = 255;
          
          outsideLEDIntensity = random(0, 100);
          outsideLEDIntensity = map(outsideLEDIntensity,0,100,0,100);
          
          intensityDifference = abs(previousOutsideLEDIntensity - outsideLEDIntensity);
          Serial.print("intensityDifference: ");
          Serial.println(intensityDifference);
          Serial.print("outsideLEDIntensity: ");
          Serial.println(outsideLEDIntensity);
          Serial.print("previousOutsideLEDIntensity: ");
          Serial.println(previousOutsideLEDIntensity);
          
          analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);
          if (intensityDifference >= 20 || outsideLEDIntensity <= 10) {
            /* Serial.print("outsideLEDIntensity: ");
            Serial.println(outsideLEDIntensity);
            Serial.print("previousOutsideLEDIntensity: ");
            Serial.println(previousOutsideLEDIntensity);
            Serial.println("--------"); */
            whiteNoise(random(1,10));
            //whiteNoise(2);
          }
          /*if (outsideLEDIntensity != 0) {
            if (previousOutsideLEDIntensity != outsideLEDIntensity) {
              Serial.print("outsideLEDIntensity: ");
              Serial.println(outsideLEDIntensity);
              Serial.print("previousOutsideLEDIntensity: ");
              Serial.println(previousOutsideLEDIntensity);
              Serial.println("--------");
              whiteNoise(2);
            }
          }*/
          
          }
          else if(lightMode == 5) {
            // progressive dim
            Serial.println("--- White progressive ---");
          
            outsideLEDIntensity = 0;
            whiteNoise(5);
            while (outsideLEDIntensity <= 255) {
              // staticNoise(5);
              analogWrite(OUTSIDELEDPIN, outsideLEDIntensity);
              //delay(waitTime);
              delay(3);
              //analogWrite(OUTSIDELEDPIN, 0);
              //delay(3);
              outsideLEDIntensity++;
            }
          delay(random(10,200));
          // delay(3000);

        }
          
      }
      delay(random(1,200));
      // Eteint l'autre
      digitalWrite(INSIDELEDPIN, LOW);
  }
  delay(30);
}
